﻿using CapaEntidades.Entidades;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CapaDatos
{
    public class CD_Productos
    {
        private CD_Conexion conexion = new CD_Conexion();
        SqlDataReader leer;
        DataTable tabla = new DataTable();
        SqlCommand comando = new SqlCommand();
        public DataTable Mostrar()
        {

            comando.Connection = conexion.AbrirConexion();
            comando.CommandText = "MostrarProductos";
            comando.CommandType = CommandType.StoredProcedure;
            leer = comando.ExecuteReader();
            tabla.Load(leer);
            conexion.CerrarConexion();
            return tabla;

        }
        public void Insertar(string nombre, string desc, string marca, double precio, int stock)
        {
            comando.Connection = conexion.AbrirConexion();
            comando.CommandText = "InsetarProductos";
            comando.CommandType = CommandType.StoredProcedure;
            comando.Parameters.AddWithValue("@nombre", nombre);
            comando.Parameters.AddWithValue("@descrip", desc);
            comando.Parameters.AddWithValue("@Marca", marca);
            comando.Parameters.AddWithValue("@precio", precio);
            comando.Parameters.AddWithValue("@stock", precio);
            comando.ExecuteNonQuery();
            comando.Parameters.Clear();
            conexion.CerrarConexion();
        }
        public void Editar(string nombre, string desc, string marca, double precio, int stock, int id)
        {
            comando.Connection = conexion.AbrirConexion();
            comando.CommandText = "EditarProductos";
            comando.CommandType = CommandType.StoredProcedure;
            comando.Parameters.AddWithValue("@nombre", nombre);
            comando.Parameters.AddWithValue("@descrip", desc);
            comando.Parameters.AddWithValue("@Marca", marca);
            comando.Parameters.AddWithValue("@precio", precio);
            comando.Parameters.AddWithValue("@stock", precio);
            comando.Parameters.AddWithValue("@id", id);
            comando.ExecuteNonQuery();
            comando.Parameters.Clear();
            conexion.CerrarConexion();
        }
        public void Eliminar(int id)
        {
            comando.Connection = conexion.AbrirConexion();
            comando.CommandText = "EliminarProducto";
            comando.CommandType = CommandType.StoredProcedure;
            comando.Parameters.AddWithValue("@idpro", id);
            comando.ExecuteNonQuery();
            comando.Parameters.Clear();
            conexion.CerrarConexion();
        }

        public void InsertarLista(List<Producto> productos)
        {
            #region OLD

            //comando.Connection = conexion.AbrirConexion();
            //comando.CommandText = "InsertarProductos";

            //#region Carga el DataTable y lo pasa al SP 'InsertarProductos'

            //DataTable productosTbl = new DataTable();
            //productosTbl.Columns.Add("Nombre", typeof(string));
            //productosTbl.Columns.Add("Descripcion", typeof(string));
            //productosTbl.Columns.Add("Marca", typeof(string));
            //productosTbl.Columns.Add("Precio", typeof(float));
            //productosTbl.Columns.Add("Stock", typeof(int));

            //foreach (Producto item in productos)
            //{
            //    productosTbl.Rows.Add(
            //        item.Nombre, 
            //        item.Descripcion, 
            //        item.Marca, 
            //        Convert.ToDouble(item.Precio), 
            //        Convert.ToInt32(item.Stock)
            //        );
            //}

            //comando.CommandType = CommandType.StoredProcedure;
            //SqlParameter parameter = comando.Parameters.AddWithValue("@Productos", productosTbl);
            //parameter.SqlDbType = SqlDbType.Structured;

            //#endregion

            //comando.ExecuteNonQuery();
            //comando.Parameters.Clear();
            //conexion.CerrarConexion();

            #endregion

            foreach (Producto item in productos)
            {
                Insertar(item.Nombre, item.Descripcion, item.Marca, Convert.ToDouble(item.Precio), Convert.ToInt32(item.Stock));
            }
        }
    }
}
