CREATE DATABASE Practica
GO

USE Practica

CREATE TABLE Productos (
    Id INT identity(1, 1) PRIMARY KEY
    ,Nombre NVARCHAR(100)
    ,Descripcion NVARCHAR(100)
    ,Marca NVARCHAR(100)
    ,Precio FLOAT
    ,Stock INT
    )

INSERT INTO Productos
VALUES (
    'Gaseosa'
    ,'3 litros'
    ,'marcacola'
    ,7.5
    ,24
    )
    ,(
    'Chocolate'
    ,'Tableta 100 gramos'
    ,'iberica'
    ,12.5
    ,36
    )

---PROCEDIMIENTOS ALMACENADOS 
--------------------------MOSTRAR 
CREATE PROC MostrarProductos
AS
SELECT *
FROM Productos
GO

--------------------------INSERTAR 
CREATE PROC InsetarProductos @nombre NVARCHAR(100)
    ,@descrip NVARCHAR(100)
    ,@marca NVARCHAR(100)
    ,@precio FLOAT
    ,@stock INT
AS
INSERT INTO Productos
VALUES (
    @nombre
    ,@descrip
    ,@marca
    ,@precio
    ,@stock
    )
GO

------------------------ELIMINAR
CREATE PROC EliminarProducto @idpro INT
AS
DELETE
FROM Productos
WHERE Id = @idpro
GO

------------------EDITAR
CREATE PROC EditarProductos @nombre NVARCHAR(100)
    ,@descrip NVARCHAR(100)
    ,@marca NVARCHAR(100)
    ,@precio FLOAT
    ,@stock INT
    ,@id INT
AS
UPDATE Productos
SET Nombre = @nombre
    ,Descripcion = @descrip
    ,Marca = @marca
    ,Precio = @precio
    ,Stock = @stock
WHERE Id = @id
GO

--------CARGAR LISTA DE PRODUCTOS

--=====CREO LA TABLA TIPO OBJETO
CREATE TYPE dbo.ProductType AS TABLE
(
    Nombre NVARCHAR(100),
    Descripcion NVARCHAR(100),
    Marca NVARCHAR(100),
    Precio FLOAT,
    Stock INT
);

--=====CREO EL SP QUE RECIBE LA TABLA TIPO OBJETO
CREATE PROC InsertarProductos 
    @Productos dbo.ProductType READONLY
AS
BEGIN
    INSERT INTO Productos (Nombre, Descripcion, Marca, Precio, Stock)
    SELECT Nombre, Descripcion, Marca, Precio, Stock
    FROM @Productos;
END;