﻿using CapaEntidades.Entidades;
using CapaNegocio;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace CapaUsuario
{
    public partial class Form1 : Form
    {
        CN_Productos objetoCN = new CN_Productos();
        private static List<Producto> productos = new List<Producto>();

        private string idProducto = null;
        private bool Editar = false;

        public Form1()
        {
            InitializeComponent();
            productos.Add(new Producto() { Nombre = "prod1", Descripcion = "a", Marca = "a", Precio = "1", Stock = "1" });
            productos.Add(new Producto() { Nombre = "prod2", Descripcion = "b", Marca = "b", Precio = "1", Stock = "1" });
            productos.Add(new Producto() { Nombre = "prod3", Descripcion = "c", Marca = "c", Precio = "1", Stock = "1" });
            productos.Add(new Producto() { Nombre = "prod4", Descripcion = "d", Marca = "d", Precio = "1", Stock = "1" });
            productos.Add(new Producto() { Nombre = "prod5", Descripcion = "e", Marca = "e", Precio = "1", Stock = "1" });
            productos.Add(new Producto() { Nombre = "prod6", Descripcion = "f", Marca = "f", Precio = "1", Stock = "1" });
            productos.Add(new Producto() { Nombre = "prod7", Descripcion = "g", Marca = "g", Precio = "1", Stock = "1" });
            productos.Add(new Producto() { Nombre = "prod8", Descripcion = "h", Marca = "h", Precio = "1", Stock = "1" });
            productos.Add(new Producto() { Nombre = "prod9", Descripcion = "i", Marca = "i", Precio = "1", Stock = "1" });
            productos.Add(new Producto() { Nombre = "prod10", Descripcion = "j", Marca = "j", Precio = "1", Stock = "1" });

            lblProgreso.Hide();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            MostrarProdctos();
        }

        private void MostrarProdctos()
        {
            CN_Productos objeto = new CN_Productos();
            dataGridView1.DataSource = objeto.MostrarProd();
        }

        private void btnGuardar_Click(object sender, EventArgs e)
        {
            //INSERTAR
            if (Editar == false)
            {
                try
                {
                    objetoCN.InsertarPRod(txtNombre.Text, txtDescripcion.Text, txtMarca.Text, txtPrecio.Text, txtStock.Text);
                    MessageBox.Show("se inserto correctamente");
                    MostrarProdctos();
                    limpiarForm();
                }
                catch (Exception ex)
                {
                    MessageBox.Show("no se pudo insertar los datos por: " + ex);
                }
            }
            //EDITAR
            if (Editar == true)
            {
                try
                {
                    objetoCN.EditarProd(txtNombre.Text, txtDescripcion.Text, txtMarca.Text, txtPrecio.Text, txtStock.Text, idProducto);
                    MessageBox.Show("se edito correctamente");
                    MostrarProdctos();
                    limpiarForm();
                    Editar = false;
                }
                catch (Exception ex)
                {
                    MessageBox.Show("no se pudo editar los datos por: " + ex);
                }
            }
        }

        private void btnEditar_Click(object sender, EventArgs e)
        {
            if (dataGridView1.SelectedRows.Count > 0)
            {
                Editar = true;
                txtNombre.Text = dataGridView1.CurrentRow.Cells["Nombre"].Value.ToString();
                txtMarca.Text = dataGridView1.CurrentRow.Cells["Marca"].Value.ToString();
                txtDescripcion.Text = dataGridView1.CurrentRow.Cells["Descripcion"].Value.ToString();
                txtPrecio.Text = dataGridView1.CurrentRow.Cells["Precio"].Value.ToString();
                txtStock.Text = dataGridView1.CurrentRow.Cells["Stock"].Value.ToString();
                idProducto = dataGridView1.CurrentRow.Cells["Id"].Value.ToString();
            }
            else
                MessageBox.Show("seleccione una fila por favor");
        }

        private void limpiarForm()
        {
            txtDescripcion.Clear();
            txtMarca.Text = "";
            txtPrecio.Clear();
            txtStock.Clear();
            txtNombre.Clear();
        }

        private void btnEliminar_Click(object sender, EventArgs e)
        {
            if (dataGridView1.SelectedRows.Count > 0)
            {
                idProducto = dataGridView1.CurrentRow.Cells["Id"].Value.ToString();
                objetoCN.EliminarPRod(idProducto);
                MessageBox.Show("Eliminado correctamente");
                MostrarProdctos();
            }
            else
                MessageBox.Show("seleccione una fila por favor");
        }

        #region Operaciones para carga masiva de datos 

        private void btnPonerEnLista_Click(object sender, EventArgs e)
        {
            productos.Add(new Producto()
            {
                Nombre = txtNombre.Text,
                Descripcion = txtDescripcion.Text,
                Marca = txtMarca.Text,
                Precio = txtPrecio.Text,
                Stock = txtStock.Text
            });

            MessageBox.Show($"Producto agregado a la lista. Cantidad: {productos.Count} productos preparados");

            txtNombre.Text = "";
            txtDescripcion.Text = "";
            txtMarca.Text = "";
            txtPrecio.Text = "";
            txtStock.Text = "";
        }

        private void btnGuardarLista_Click(object sender, EventArgs e)
        {
            if (productos.Count > 0)
            {
                try
                {
                    btnGuardarLista.Enabled = false;
                    progressBar1.Visible = true;
                    lblProgreso.Show();

                    backgroundWorker1.RunWorkerAsync();

                    //objetoCN.InsertarListaProd(productos);
                    //MostrarProdctos();
                    //limpiarForm();
                }
                catch (Exception ex)
                {
                    MessageBox.Show("Error al ejecutar 'InsertarProductos': " + ex);
                }
            }
        }

        #endregion

        #region Carga con barra de progreso

        private void backgroundWorker1_DoWork(object sender, DoWorkEventArgs e)
        {
            //objetoCN.InsertarListaProd(productos);
            int i = 0;
            foreach (Producto item in productos)
            {
                if (i % 2 == 0)
                {
                    System.Threading.Thread.Sleep(500); // 1 seg por cada 2 inserts
                }

                objetoCN.InsertarPRod(
                    item.Nombre,
                    item.Descripcion,
                    item.Marca,
                    item.Precio,
                    item.Stock
                    );

                //int progreso = (i + 1) * 100 / productos.Count;
                int progreso = (i + 1) * 100 / productos.Count;
                backgroundWorker1.ReportProgress(progreso);
                i += 1;
            }
        }

        private void backgroundWorker1_ProgressChanged(object sender, ProgressChangedEventArgs e)
        {
            progressBar1.Value = e.ProgressPercentage;
        }

        private void backgroundWorker1_RunWorkerCompleted(object sender, RunWorkerCompletedEventArgs e)
        {
            btnGuardarLista.Enabled = true;
            progressBar1.Visible = false;
            lblProgreso.Hide();

            MessageBox.Show($"Se agregaron {productos.Count} productos!");
            productos.Clear();

            MostrarProdctos();
        }

        #endregion
    }
}
